<?php
// ________________________________________________________
// find fully qualified path to script
function scriptPath() {
	$path='http://'.$_SERVER['HTTP_HOST'].$_SERVER['PHP_SELF'];
	$p=strrpos($path, '/');
	if ($p>0) $path=substr($path, 0, $p+1);

	return $path;
}


// ________________________________________________________
// define a cookie
function writeCookie($name, $value='') {
	if ($value=='') setcookie($name);
	else setcookie($name, $value);
}


// ________________________________________________________
// read the value of a cookie
function readCookie($name, $default='') {
	if (isset($_COOKIE[$name])) {
		$ret=$_COOKIE[$name];
		if (get_magic_quotes_gpc()) $ret=stripslashes($ret);
	}
	else {
		$ret=$default;
	}

	return $ret;
}


// ________________________________________________________
// fetches a POST form variable or sets to a default
function postvar($var, $default='') {
	if (isset($_POST[$var])) {
		$ret=$_POST[$var];
		if (get_magic_quotes_gpc()) $ret=stripslashes($ret);
	}
	else {
		$ret=$default;
	}

	$ret=str_replace('&', '&amp;', $ret);
	$ret=str_replace('<', '&lt;', $ret);
	$ret=str_replace('>', '&gt;', $ret);

	return $ret;
}


// ________________________________________________________
// fetches a GET form variable or sets to a default
function getvar($var, $default='') {
	if (isset($_GET[$var])) {
		$ret=$_GET[$var];
		if (get_magic_quotes_gpc()) $ret=stripslashes($ret);
	}
	else {
		$ret=$default;
	}

	$ret=str_replace('&', '&amp;', $ret);
	$ret=str_replace('<', '&lt;', $ret);
	$ret=str_replace('>', '&gt;', $ret);

	return $ret;
}


// ________________________________________________________
// SQL escape
function SQLescape($var) {

	if (is_bool($var)) {
		if ($var) $ret=1; else $ret=0;
	}
	else if (is_numeric($var)) {
		$ret=intval($var);
	}
	else {
		$ret="'".str_replace("'", "''", $var)."'";
	}

	return $ret;
}


// ________________________________________________________
// define a hidden value
function doHidden($fieldname, $fieldvalue='') {
	print "<input type=\"hidden\" name=\"$fieldname\" value=\"$fieldvalue\" />";
}


// ________________________________________________________
// truncate an email to n characters
function truncEmail($email, $max=10) {
	$pos=strpos($email, '@');
	if ($pos>0) $email=substr($email, 0, $pos);
	if (strlen($email)>$max) $email=substr($email, 0, 10)."...";
	return $email;
}


// ________________________________________________________
// truncate a string to between min and max characters
function truncString($string='', $min=0, $max=0) {
	$ret=$string;
	if (strlen($ret)>$max && $min<=$max) {
		$p=$max;
		$found=false;
		do {
			$p--;
			if (strpos(" .,/;:'@#~[]{}!%&*()-_=+\"", substr($ret, $p, 1))!==false) $found=true;
		}
		while (!$found && $p>=$min);
		if (!$found) $p=$max;
		$ret=substr($string, 0, $p).'...';
	}
	return $ret;
}


// ________________________________________________________
// convert SQL time (YYYYMMDDHHMMSS) to PHP time value
function timeconv($st='') {
	$st=str_pad($st, 14, "0", STR_PAD_RIGHT);
	return mktime(intval(substr($st,8,2)), intval(substr($st,10,2)), intval(substr($st,12,2)), intval(substr($st,4,2)), intval(substr($st,6,2)), intval(substr($st,0,4)));
}


// ________________________________________________________
// do not change in any way , or the system will randomly delete your data!
function regcheck() {
	$regcopy=false;
	$key='';
	if (defined('LICENCEKEY')) $key=strtolower(trim(LICENCEKEY));
	if (strlen($key)>10) {
		$code=substr($key, 0, 10);
		$chk=substr($key, 10);
		if (sprintf("%x",crc32($code))==$chk) $regcopy=true;
	}
	return $regcopy;
}


// ________________________________________________________
// create a file and write to it
function createFile($filename='', $text='') {

	$ret=false;

	if ($filename!='') {
		if ($fp=@fopen($filename, 'w')) {
			fwrite($fp, $text);
			fclose($fp);
			$ret=true;
		}
	}

	return $ret;
}


// ________________________________________________________
// add to error log
function writeLog($logfile, $errortext='') {
	if ($fp=@fopen($logfile, 'a')) {
		fwrite($fp, gmdate('[d-m-y H:i] ').$errortext);
		fclose($fp);
	}
}


// ________________________________________________________
// recursively delete a folder and all contents
function deleteFolder($folder) {

	if ($dir=@opendir($folder)) {

		$done=true;

		// delete all files and subfolders
		while (($file=readdir($dir))!==false && $done) {

			if ($file!='.' && $file!='..') {

				$fname=$folder.'/'.$file;

				if (is_dir($fname)) {
					// delete subfolder
					$done=deleteFolder($fname);
				}
				else {
					// delete file
					@chmod($fname, 0666);
					$done=@unlink($fname);
				}
			}

		}

	}
	else $done=false;

	// delete folder
	if ($done) {
		@chmod($folder, 0755);
		$done=@rmdir($folder);
	}

	return $done;
}


// ________________________________________________________
// generate PHP and JavaScript datafiles
function generateFiles($site, $fullurl, $datafolder) {

	global $db;

	$ret='';
	$jscode='';
	$doNULL=false;

	// file locations setup
	$thumburl=$fullurl.$datafolder.$site->siteid.'/thumbs/';
	$picurl=$fullurl.$datafolder.$site->siteid.'/pics/';
	$JSfile=$datafolder.$site->siteid.'/vehicles.js';

	// site settings
	$jscode.="setup.site=\"$site->siteid\";\n";
	$jscode.="setup.locale=\"$site->currency\";\n";
	$jscode.="setup.searchURL=\"${fullurl}carlistsearch.php?site=$site->siteid&search=\";\n";
	$jscode.="setup.viewURL=\"${fullurl}viewupdate.php?site=$site->siteid&amp;id=\";\n";
	$jscode.="setup.emailURL=\"${fullurl}emailsales.php?site=$site->siteid&id=\";\n";
	$jscode.="setup.thumburl=\"$thumburl\";\n";
	$jscode.="setup.picurl=\"$picurl\";\n";
	$jscode.="setup.picsize=$site->picdimension;\n";
	$jscode.='setup.licprod='.(regcheck() ? 'true' : 'false').";\n";
	$jscode.='setup.showform='.($site->emailsales == '' ? 'false' : 'true').";\n";
	$jscode.='setup.adverton='.($site->adverton ? 'true' : 'false').";\n";
	$jscode.='setup.orderbyon='.($site->orderbyon ? 'true' : 'false').";\n";

	// advert text and link
	$advert='';
	$advertURL='';
	if (defined('ADVERT')) $advert=ADVERT;
	if (defined('ADVERTURL')) $advertURL=ADVERTURL;
	if ($advert=='') {
		$advert='powered by AutoDirector';
		$advertURL='http://www.autodirector.co.uk/';
	}
	$jscode.="setup.advert=\"$advert\";\n";
	$jscode.="setup.advertURL=\"$advertURL\";\n\n";

	$jscode.="var vehiclelist;\n";
	$jscode.="function DefineVehicles() {\n";
	$jscode.="\tvehiclelist=[];\n";

	if ($site->blockgenerate) {

		$doNULL=true;
		$ret.='<i>YOUR PERMISSONS HAVE BEEN REVOKED: VEHICLES WILL NOT BE LISTED ON YOUR SITE</i><br />';

	}
	else {

		// fetch vehicles from database and write to datafiles
		$db->pagesize=0;
		if ($db->fetch('SELECT id,new,year,make,model,type,mileage,colour,gearbox,info,price,picturelist FROM '.$site->siteid.' WHERE display=1 ORDER BY price DESC, new DESC, year DESC;')) {

			$numcars=$db->rowcount;
			for ($i=0; $i<$numcars; $i++) {

				// fetch next car
				$car=$db->rowassoc();

				// car year
				$year = ($car['new'] ? date('Y') : $car['year']);

				// car name
				$carname=trim("${car['make']} ${car['model']} ${car['type']}");

				// mileage
				$mileage = $car['mileage'];

				// colour
				$colour=str_replace("\"", '\"', $car['colour']);

				// gearbox
				$gearbox = ($car['gearbox']=='unknown' ? '' : $car['gearbox']);

				// price
				$price=(is_numeric($car['price']) ? $car['price'] : 'null');

				// information
				$info=str_replace("\"", '\"', $car['info']);
				$info=str_replace("\n", '|', $info);
				$info=str_replace("\r", '', $info);
				do {
					$oldinfo = $info;
					$info=str_replace("||", '|', $info);
				} while ($oldinfo != $info);
				$info=preg_replace('/\|\s+/', '|', $info); // trim empty string at start of line
				$info=preg_replace('/\s+\|/', '|', $info); // trim empty string at end of line

				// update code
				$jscode.="\tvehiclelist[$i]=new Vehicle(${car['id']}, ".($car['new'] ? 'true' : 'false').", $year, \"$carname\", $mileage, \"$colour\", \"$gearbox\", \"$info\", $price, [${car['picturelist']}]);\n";

				// mapping array
				$idmap[intval($car['id'])]=$i;
			}

		}
		else {
			$doNULL=true;
			$ret='Your vehicle list could not be extracted from the database - vehicles will not appear on your web site.<br />';
		}

	}

	$jscode.="}\n";

	// searching on/off
	$searchon = ($site->searchon && isset($numcars) && $numcars >= 10 ? 'true' : 'false');
	$jscode.="setup.searchon=$searchon;\n\n";

	// save data to files
	if (!createFile($JSfile, $jscode)) { $ret.='Your vehicle list could not be saved to '.$JSfile.'.<br />'; }
	if ($ret!='' && !$doNULL) $ret.='Please try again or contact your administrator if this error continues to occur.';

	return $ret;
}
?>
